<template>
  <table class="cd__table">

    <tbody v-if="!currentSettings.countTo">
    <tr>
      <td>{{ t("configure_message") }}</td>
    </tr>
    </tbody>
    <tbody v-else-if="finished">
    <tr>
      <td class="cd__finished">
        {{ t("finished_message") }}
      </td>
    </tr>
    </tbody>
    <template v-else>
      <tbody>
      <tr class="cd__numbers">
        <td>{{ countdown.days }}</td>
        <td>:</td>
        <td>{{ countdown.hours | padZero }}</td>
        <td>:</td>
        <td>{{ countdown.minutes | padZero }}</td>
        <td>:</td>
        <td>{{ countdown.seconds | padZero }}</td>
      </tr>
      </tbody>
      <tfoot>
      <tr class="cd__footer">
        <th>{{ t("days_label") }}</th>
        <th></th>
        <th>{{ t("hours_label") }}</th>
        <th></th>
        <th>{{ t("minutes_label") }}</th>
        <th></th>
        <th>{{ t("seconds_label") }}</th>
      </tr>
      </tfoot>
    </template>
  </table>
</template>

<script>
module.exports = {
  name: "countdown",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    currentDimensions: {
      type: Object,
      required: true,
    },
    sourcesConfigured: {
      type: Boolean,
      required: false,
    },
    records: {
      type: Array,
      required: false,
    },
    language: {
      type: String,
      required: true,
    },
    locale: {
      type: String,
      required: true,
    },
    backendUrl: {
      type: String,
      required: true,
    },
    fetchAsset: {
      type: Function,
      required: false,
    },
  },
  watch: {
    currentSettings: {
      immediate: true,
      handler: function (newVal) {
        if (newVal.countTo === null) return;

        /*
        INFO: WPE WebKit parses datetime strings without timezone specifiers as UTC, though the spec says it should be local time. buildTimezoneOffset() adds the correct timezone difference string.
      */
        this.countTo = Date.parse(
            `${newVal.countTo}${this.buildTimezoneOffset()}`
        );
        this.finished = false;
        this.updateCountdown();
        this.$options.countdownUpdate = setInterval(this.updateCountdown, 1000);
      },
    },
  },
  data: function () {
    return {
      countTo: null,
      countdown: null,
      finished: false,
    };
  },
  beforeDestroy: function () {
    clearInterval(this.$options.countdownUpdate);
  },
  filters: {
    /**
     * Pads an integer input with `0` if it is single-digit.
     * @param {number} input
     * @returns {string}
     */
    padZero: function (input) {
      return input < 10 ? `0${input}` : input.toString();
    },
  },
  methods: {
    buildTimezoneOffset: function () {
      /*
    CAUTION: The getTimezoneOffset() method returns the time zone difference, in minutes, from current locale (host system settings) to UTC. I.e. for CEST, it's -120 minutes, but to get the actual offset *from* UTC *to* local timezone, we need to invert this.
    */
      const offset = new Date().getTimezoneOffset() / 60;
      const sign = Math.sign(offset) >= 0 ? "-" : "+";
      let hours = "";
      if (String(Math.abs(offset)).length === 1) {
        hours = `${sign}0${Math.abs(offset)}:00`;
      } else {
        hours = `${sign}${Math.abs(offset)}:00`;
      }
      return hours;
    },
    updateCountdown: function () {
      const t = this.countTo - Date.now(); // Epoch timestamp in milliseconds
      if (t > 0) {
        const seconds = Math.floor((t / 1000) % 60);
        const minutes = Math.floor((t / 60000) % 60); // 1000 * 60
        const hours = Math.floor((t / 3600000) % 24); // 1000 * 60 * 60
        const days = Math.floor(t / 86400000); // 1000 * 60 * 60 * 24
        this.countdown = {
          total: t,
          days: days,
          hours: hours,
          minutes: minutes,
          seconds: seconds,
        };
      } else {
        clearInterval(this.$options.countdownUpdate);
        this.countdown = {
          total: 0,
          days: 0,
          hours: 0,
          minutes: 0,
          seconds: 0,
        };
        this.finished = true;
      }
    },
  },
  locales: {
    enGb: {
      configure_message: "Please set a date first!",
      finished_message: "Finished!",
      days_label: "days",
      hours_label: "hours",
      minutes_label: "minutes",
      seconds_label: "seconds",
    },
    deDe: {
      configure_message: "Bitte setze zuerst ein Datum!",
      finished_message: "Geschafft!",
      days_label: "Tage",
      hours_label: "Stunden",
      minutes_label: "Minuten",
      seconds_label: "Sekunden",
    },
    frFr: {
      configure_message: "Veuillez d'abord fixer une date !",
      finished_message: "Nous l'avons fait !",
      days_label: "Journées",
      hours_label: "heures",
      minutes_label: "procès-verbal",
      seconds_label: "secondes",
    },
    esEs: {
      configure_message: "¡Por favor, fija una fecha primero!",
      finished_message: "¡Lo hicimos!",
      days_label: "Días",
      hours_label: "horas",
      minutes_label: "minutos",
      seconds_label: "segundos",
    },
    plPl: {
      configure_message: "Proszę najpierw ustalić datę!",
      finished_message: "Udało nam się!",
      days_label: "Dni",
      hours_label: "Godziny",
      minutes_label: "Minuty",
      seconds_label: "Sekundy",
    },
    koKr: {
      configure_message: "먼저 날짜를 설정하세요!",
      finished_message: "완전한",
      days_label: "일",
      hours_label: "시간",
      minutes_label: "의사록",
      seconds_label: "초",
    },
  },
};
</script>
<style>
.cd__table {
  border-spacing: 0 0.5rem;
  font-variant-numeric: tabular-nums;
}

.cd__numbers td {
  text-align: center;
}

.cd__footer th {
  text-align: center;
  font-size: 65%;
}

.cd__numbers td:nth-of-type(odd) {
  width: 20%;
}

.cd__numbers td:nth-of-type(even) {
  width: 6.6666666667%;
}

.cd__numbers,
.cd__finished {
  font-size: 280%;
}

.font-inter .cd__numbers {
  font-size: 200%;
}
</style>
